---
title: 'CSP: form-action'
slug: Web/HTTP/Headers/Content-Security-Policy/form-action
tags:
  - CSP
  - Content-Security-Policy
  - Directive
  - HTTP
  - Security
  - action
  - form
  - form-action
---
<div>{{HTTPSidebar}}</div>

<p>The HTTP {{HTTPHeader("Content-Security-Policy")}} (CSP) <code><strong>form</strong></code><strong><code>-action</code></strong> directive restricts the URLs which can be used as the target of a form submissions from a given context.</p>

<div class="warning">
<p>Whether <code>form-action</code> should block redirects after a form submission is <a href="https://github.com/w3c/webappsec-csp/issues/8">debated</a> and browser implementations of this aspect are inconsistent (e.g. Firefox 57 doesn't block the redirects whereas Chrome 63 does).</p>
</div>

<table class="properties">
	<tbody>
		<tr>
			<th scope="row">CSP version</th>
			<td>2</td>
		</tr>
		<tr>
			<th scope="row">Directive type</th>
			<td>{{Glossary("Navigation directive")}}</td>
		</tr>
		<tr>
			<th scope="row">{{CSP("default-src")}} fallback</th>
			<td>No. Not setting this allows anything.</td>
		</tr>
	</tbody>
</table>

<h2 id="Syntax">Syntax</h2>

<p>One or more sources can be set for the <code>form-action</code> policy:</p>

<pre class="syntaxbox notranslate">Content-Security-Policy: form-action &lt;source&gt;;
Content-Security-Policy: form-action &lt;source&gt; &lt;source&gt;;
</pre>

<h3 id="Sources">Sources</h3>

<p>{{page("Web/HTTP/Headers/Content-Security-Policy/default-src", "Sources")}}</p>

<h2 id="Examples">Examples</h2>

<h3 id="Meta_tag_configuration">Meta tag configuration</h3>

<pre class="brush: html notranslate">&lt;meta http-equiv="Content-Security-Policy" content="form-action 'none'"&gt;</pre>

<h3 id="Apache_configuration">Apache configuration</h3>

<pre class="brush: bash notranslate">&lt;IfModule mod_headers.c&gt;
Header set Content-Security-Policy "form-action 'none';"
&lt;/IfModule&gt;</pre>

<h3 id="Nginx_configuration">Nginx configuration</h3>

<pre class="brush: bash notranslate">add_header Content-Security-Policy "form-action 'none';"</pre>

<h3 id="Violation_case">Violation case</h3>

<p>Using a {{HTMLElement("form")}} element with an action set to inline JavaScript will result in a CSP violation.</p>

<pre class="brush: html; example-bad notranslate">&lt;meta http-equiv="Content-Security-Policy" content="form-action 'none'"&gt;

&lt;form action="javascript:alert('Foo')" id="form1" method="post"&gt;
  &lt;input type="text" name="fieldName" value="fieldValue"&gt;
  &lt;input type="submit" id="submit" value="submit"&gt;
&lt;/form&gt;

// Error: Refused to send form data because it violates the following
// Content Security Policy directive: "form-action 'none'".</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{specName("CSP 3.0", "#directive-form-action", "form-action")}}</td>
			<td>{{Spec2('CSP 3.0')}}</td>
			<td>No changes.</td>
		</tr>
		<tr>
			<td>{{specName("CSP 1.1", "#directive-form-action", "form-action")}}</td>
			<td>{{Spec2('CSP 1.1')}}</td>
			<td>Initial definition.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("http.headers.csp.Content-Security-Policy.form-action")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>{{HTTPheader("Content-Security-Policy")}}</li>
	<li>{{HTMLElement("form")}}</li>
</ul>
